<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="游客姓名" prop="guestName">
        <el-input v-model="queryParams.guestName" placeholder="请输入游客姓名" clearable size="small" @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="身份证号" prop="idCard">
        <el-input v-model="queryParams.idCard" placeholder="请输入身份证号" clearable size="small" @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="手机号码" prop="phone">
        <el-input v-model="queryParams.phone" placeholder="请输入手机号码" clearable size="small" @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5"><el-button type="primary" icon="el-icon-plus" @click="handleAdd" v-hasPermi="['management:guestRecord:add']">新增</el-button></el-col>
      <el-col :span="1.5">
        <el-button type="success" icon="el-icon-edit" :disabled="single" @click="handleUpdate" v-hasPermi="['management:guestRecord:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" icon="el-icon-delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['management:guestRecord:remove']">删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" border :data="guestRecordList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="名称" align="center" prop="shopName" />
      <el-table-column label="游客姓名" align="center" prop="guestName" />
      <el-table-column label="身份证号" align="center" prop="idCard" />
      <el-table-column label="手机号码" align="center" prop="phone" />
      <el-table-column label="入住日期" align="center" prop="checkInTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.checkInTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="游客类型" align="center" prop="guestType" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['management:guestRecord:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="['management:guestRecord:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改酒店客人数据记录对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="店铺" prop="shopId">
          <!-- <el-input v-model="form.shopId" placeholder="请输入店铺id" /> -->
          <el-select v-if="shopList" v-model="form.shopId">
            <el-option v-for="(item, index) in shopList" :key="'shop' + index" :label="item.name" :value="item.shopId"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="游客姓名" prop="guestName"><el-input v-model="form.guestName" placeholder="请输入游客姓名" /></el-form-item>
        <el-form-item label="身份证号" prop="idCard"><el-input v-model="form.idCard" placeholder="请输入身份证号" /></el-form-item>
        <el-form-item label="手机号码" prop="phone"><el-input type="number" v-model="form.phone" placeholder="请输入手机号码" /></el-form-item>
        <el-form-item label="入住日期" prop="checkInTime">
          <el-date-picker clearable size="small" v-model="form.checkInTime" type="date" value-format="yyyy-MM-dd" placeholder="选择入住日期"></el-date-picker>
        </el-form-item>
        <el-form-item label="游客类型" prop="guestType">
          <!-- <el-select v-model="form.guestType" placeholder="请选择游客类型">
            <el-option label="请选择字典生成" value="" />
          </el-select> -->
          <el-select v-model="form.guestType" placeholder="请选择游客类型">
            <el-option label="散客" value="散客" />
            <el-option label="团客" value="团客" />
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listGuestRecord, getGuestRecord, delGuestRecord, addGuestRecord, updateGuestRecord, exportGuestRecord } from '@/api/management/guestRecord';
import { shopSelect } from '@/api/management/shop';
export default {
  name: 'GuestRecord',
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 酒店客人数据记录表格数据
      guestRecordList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        guestName: null,
        idCard: null,
        phone: null,
        orderByColumn: 'createTime', //排序字段
        isAsc: 'desc' //排序方式
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        shopId: [{ required: true, message: '店铺不能为空' }],
        guestName: [{ required: true, message: '游客姓名不能为空' }],
        idCard: [
          {
            trigger: 'blur',
            validator: (rule, value, callback) => {
              const reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
              if (value == '' || value == undefined || value == null) {
                callback();
              } else {
                if (!reg.test(value) && value != '') {
                  callback(new Error('请输入正确的身份证号码'));
                } else {
                  callback();
                }
              }
            }
          }
        ],
        phone: [
          {
            trigger: 'blur',
            validator: (rule, value, callback) => {
              const reg = /^[1][3,4,5,7,8][0-9]{9}$/;
              if (value == '' || value == undefined || value == null) {
                callback();
              } else {
                if (!reg.test(value) && value != '') {
                  callback(new Error('请输入正确的电话号码'));
                } else {
                  callback();
                }
              }
            }
          }
        ]
      },
      shopList: []
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询酒店客人数据记录列表 */
    getList() {
      this.loading = true;
      listGuestRecord(this.queryParams).then(response => {
        this.guestRecordList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        shopGuestRecord: null,
        shopId: null,
        guestName: null,
        idCard: null,
        phone: null,
        checkInTime: null,
        guestType: null,
        createTime: null
      };
      this.resetForm('form');
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm');
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.shopGuestRecord);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = '添加酒店客人数据记录';
      this.getShopList();
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const shopGuestRecord = row.shopGuestRecord || this.ids;
      getGuestRecord(shopGuestRecord).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = '修改酒店客人数据记录';
        this.getShopList();
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.shopGuestRecord != null) {
            updateGuestRecord(this.form).then(response => {
              this.msgSuccess('修改成功');
              this.open = false;
              this.getList();
            });
          } else {
            addGuestRecord(this.form).then(response => {
              this.msgSuccess('新增成功');
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const shopGuestRecords = row.shopGuestRecord || this.ids;
      this.$confirm('是否确认删除酒店客人数据记录编号为"' + shopGuestRecords + '"的数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(function() {
          return delGuestRecord(shopGuestRecords);
        })
        .then(() => {
          this.getList();
          this.msgSuccess('删除成功');
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有酒店客人数据记录数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(() => {
          this.exportLoading = true;
          return exportGuestRecord(queryParams);
        })
        .then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        })
        .catch(() => {});
    },
    getShopList() {
      shopSelect().then(res => {
        this.shopList = res.rows;
      });
    }
  }
};
</script>
